void EvalDMX() { 
  if (UIMode == UI_MODE_DMX) {
    if (dmxvalue[0] < 64) {
      // Direct DMX color control
      if (OPMode != OP_MODE_DMX) {
        SetupDMX();
      }
    } else if (dmxvalue[0] < 128) {
      // Color strobe effect
      if (OPMode != OP_MODE_PROG_2) {
        SetupProg2();
      }
    } else if (dmxvalue[0] < 192) {
      // Sequential fader
      if (OPMode != OP_MODE_PROG_3) {
        SetupProg3();
      }
    } else {
      // Random fader
      if (OPMode != OP_MODE_PROG_4) {
        SetupProg4();
      }
    }
    
    // Set the color values for modes that require it
    if ((OPMode == OP_MODE_DMX) || (OPMode == OP_MODE_PROG_2)) {
      CurRed = ScaleColor(dmxvalue[2]);
      CurGreen = ScaleColor(dmxvalue[3]);
      CurBlue = ScaleColor(dmxvalue[4]);
      
      // Immediately update the PWM outputs if we are in Direct DMX Control mode
      if (OPMode == OP_MODE_DMX) {
        SetPWM(CurRed, CurGreen, CurBlue);
      }
    }
  }

  return;
}


// Scale the passed color with the master intensity channel
byte ScaleColor(byte C) {
  unsigned int TempInt = C * dmxvalue[1]; // Result {[7:0] "." [7:0]}
  byte newC = (TempInt >> 8);
  
  // Always round the fractional part of the multiplication up to the next int value
  if ((TempInt & 0xFF) > 0x0) {
    // Round up
    return (newC + 1);
  } else {
    // No rounding
    return (newC);
  }
}



void SetupDMX() {
  OPMode = OP_MODE_DMX;
}


void EvalUiDMX() {
  // Look for button presses
  if (ButtonPressShort) {
    // Move to program 1
    UIMode = UI_MODE_PROG_1;
    SetupProg1();
    SetupProg1Display();
  }
  else if (ButtonPressLong) {
    // Move to address setup
    SetupSetAddr();
  }
}
